com.amazonaws.codegen.emitters.tasks

## Class BaseGeneratorTasks

- java.lang.Object
- - com.amazonaws.codegen.emitters.tasks.BaseGeneratorTasks

All Implemented Interfaces:
  Iterable<GeneratorTask>

Direct Known Subclasses:
  AsyncClientGeneratorTasks, BaseExceptionClassGeneratorTasks, MarshallerGeneratorTasks, ModelClassGeneratorTasks, PackageInfoGeneratorTasks, PolicyActionEnumGeneratorTasks, SmokeTestsGeneratorTasks, SyncClientGeneratorTasks, UnmarshallerGeneratorTasks, WaitersGeneratorTasks

    public abstract class BaseGeneratorTasks
    extends Object
    implements Iterable<GeneratorTask>

### Field Summary

Fields
`protected com.amazonaws.codegen.internal.Freemarker` `freemarker`
`protected org.apache.commons.logging.Log` `log`
`protected IntermediateModel` `model`

### Constructor Summary

Constructors
Constructor and Description
`BaseGeneratorTasks(GeneratorTaskParams dependencies)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`protected abstract List<GeneratorTask>` `createTasks()`
`protected boolean` `hasTasks()` Hook to allow subclasses to indicate they have no tasks so they can assume when createTasks is called there's something to emit.
`protected void` `info(String message)`
`Iterator<GeneratorTask>` `iterator()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.lang.Iterable

`forEach, spliterator`

### Field Detail

#### model

    protected final IntermediateModel model

#### freemarker

    protected final com.amazonaws.codegen.internal.Freemarker freemarker

#### log

    protected final org.apache.commons.logging.Log log

### Constructor Detail

#### BaseGeneratorTasks

    public BaseGeneratorTasks(GeneratorTaskParams dependencies)

### Method Detail

#### info

    protected void info(String message)

#### hasTasks

    protected boolean hasTasks()

Hook to allow subclasses to indicate they have no tasks so they can assume when createTasks is called there's something to emit.

#### createTasks

    protected abstract List<GeneratorTask> createTasks()
                                                throws Exception

Throws:
  `Exception`

#### iterator

    public Iterator<GeneratorTask> iterator()

Specified by:
  `iterator` in interface `Iterable<GeneratorTask>`